package infpp.oceanlife;

import java.util.LinkedList;

/**
 * 
 * Implements the following methods: getWidth, setWidth, getDepth,
 *            setDepth, getOceanObjects, initialiseOceanObjects, toString,
 *            addOceanOceanObject, removeOceanObjetct.           
 * @author tdu, akue
 */
public interface OceanInterface {
	/**
	 * @return Returns the width of the ocean.
	 */
	public int getWidth();

	/**
	 * @param width
	 *            the width to set
	 * @throws Exception
	 *             if the width is negative
	 */
	public void setWidth(int width) throws Exception;

	/**
	 * @return Returns the depth of the ocean.
	 */
	public int getDepth();

	/**
	 * @param depth
	 *            the depth to set
	 * @throws Exception
	 *             if the depth is negative
	 */
	public void setDepth(int depth) throws Exception;

	/**
	 * @return Returns all ocean objects.
	 */
	public LinkedList<OceanObject> getOceanObjects();

	/**
	 * @param oceanObjects
	 *            the list of ocean objects to go into the ocean.
	 * @throws Exception
	 *             if something went wrong during the initialisation, such as
	 *             objects being outside of the ocean.
	 */
	public void initialiseOceanObjects(LinkedList<OceanObject> oceanObjects)
			throws Exception;

	@Override
	/**
	 * @return Returns a string representation of the ocean.
	 */
	public String toString();

	/**
	 * @param obj
	 *            the object to add
	 * @throws Exception
	 *             if the object cannot be added, eg due to a collision with an
	 *             existing object or it being added outside of the ocean.
	 */
	public void addOceanObject(OceanObject obj) throws Exception;

	
	/**
	 * @param x the list index of the object in question.
	 * @throws Exception if no object exists at the given index.
	 */
	public void removeOceanObject(int x) throws Exception;
}
