package infpp.oceanlife;

import static java.lang.Math.abs;
import static java.lang.Math.random;

import javax.swing.ImageIcon;

/**
 *        Implements objects of the type oil blob. The coordinates and the
 *        icon are given from the super class "OceanObject". The movement
 *        direction is defined here.
 * @author tdu, akue
 *  
 */
public class OilBlob extends OceanObject {
    
	/**
     * Sets the width of the x-direction of the bubble's movement.
     */
    private int dir0 = 4; // 2
    
    
    /**
     * Sets the amplitude of the x-direction of the bubble's movement.
     */
    private int dir1 = -8; // -4
    
    /**
     * Sets the width of the y-direction of the bubble's movement. 
     */
    private int dir2 = -10; // -3
    
    /**
     * Sets the amplitude of the y-direction of the bubble's movement. 
     */
    private int dir3 = 5; // 1
    
    

    /**
	 * @param x
	 *            the oil blob's x coordinate
	 * @param y
	 *            the oil blob's y coordinate
	 * @param currentOcean
	 *            the ocean the oil blob resides in
	 * @throws throws exception for the position
	 */
    public OilBlob(int x, int y, ImageIcon oilBlobIcon, Ocean currentOcean)
	    throws Exception {
	super(x, y, oilBlobIcon, currentOcean);
	// TODO Auto-generated constructor stub
    }

    
    
    /**
	 * Updates the oil blob's direction vector
	 * 		   Switch statement for the cases when the oil blob collides with
	 *         the ocean bounds. 
	 * 		   The oil blob is not removed when it collides with the upper
	 *         bound. Exception for removing the bubble is caught here.
	 */
    @Override
    protected void updateDirection() {
        // TODO Auto-generated method stub
        //super.updateDirection();
	
	this.direction[0] = (int) (dir0 + dir1 * random());
	this.direction[1] = (int) (dir2 + dir3 * random());

	switch (objectCollidesWithOceanBounds()) {

	case OceanObject.COLLISION_LEFT_BOUND:
	    dir0 = abs(dir0);
	    dir1 = -abs(dir1);
	    direction[0] = 0;
	    break;

	case OceanObject.COLLISION_RIGHT_BOUND:
	    dir0 = -abs(dir0);
	    dir1 = abs(dir1);
	    direction[0] = 0;
	    break;

	case OceanObject.COLLISION_LOWER_BOUND:
	    dir2 = -abs(dir2);
	    dir3 = abs(dir3);
	    direction[1] = 0;
	    break;

	case OceanObject.COLLISION_UPPER_BOUND:
	    dir2 = abs(dir2);
	    dir3 = -abs(dir3);
	    	    
	    direction[1] = 0;
	    
	    
	    
	    break;

	case NO_COLLISION:
	    break;
	}

    }
    
    @Override
    /**
	 * @see infpp.oceanlife.OceanObject#toString()
	 * 
	 * @return The subclass name "OilBlob" and the height of the Icon is
	 * printed; includes the super class "toString".
	 */
    
    public String toString() {
	// TODO Auto-generated method stub

	System.out.println(this.getObjectIcon().getIconHeight());
	return "OilBlob" + super.toString();
    }
    
    
    }
    

